#!/bin/bash
#
# Befor you start, you need to edit the 2 
# variables SCANBASE and MOVIEFOLDER
#
# This is the base-file for the frequency-scan.
# Chose the one corresponding to your location.
SCANBASE="/usr/share/dvb/dvb-t/de-Schleswig-Holstein"

# Folder where the movies are stored.
# IMPORTANT: Use the full path, don't use ~ for your home!
# Example:
# MOVIEFOLDER="/home/tux/tv/"
MOVIEFOLDER=""

# If you want, you could change the values for the converted videos
AUDIOBITRATE="128k"
VIDEOBITRATE="2000k"

MAINLOOP=1
if [ "$MOVIEFOLDER" == "" ]; then
   MAINLOOP=0
   echo -e "\nYou need to edit the variables SCANBASE and MOVIEFOLDER in the top of the script before you can use it.\n"
fi

clear
while [ ${MAINLOOP} -gt 0 ]; do
   echo "************************************"
   echo "***         tv-star 0.7          ***"
   echo "***      by Thomas Schuetz       ***"
   echo "************************************"
   echo -e "\n"
   echo "w: Watch TV"
   echo "r: Record a movie"
   echo "c: Cancel the record of a movie"
   echo "m: Convert recorded movie into MPEG2"
   echo "p: Play recorded movie"
   echo "d: Delete recorded movie"
   echo "s: Shutdown at a specified time"
   echo "i: Informationen about tv-star.sh"
   echo "n: New channel.conf"
   echo "q: Quit"
   echo -e -n "\nYour choice: "
   read INPUT
   echo -e "\n"
   case $INPUT in
      w) echo "************************************"
         echo "***           Watch TV           ***"
         echo "************************************"
         echo -e "\n"
         echo "Please chose the station you want to watch:"
         NUMBER=0
         for LINE in `cat ~/.mplayer/channels.conf | sed  s/:.*//`; do
            NUMBER=$((NUMBER+1))
            echo -n ${NUMBER}") "
            echo ${LINE};
         done
         echo -e -n "\nYour choice: "
         read STATION
         STATIONNAME=`tail -n +$STATION ~/.mplayer/channels.conf | head -n 1 | sed s/:.*//`
         mplayer dvb://${STATIONNAME}
         ;;
      r) echo "**************************************"
         echo "***         Record a movie         ***"
         echo "**************************************"
         echo -e "\n"
         echo "Please chose the station where you want to record a movie:"
         NUMBER=0
         for LINE in `cat ~/.mplayer/channels.conf | sed  s/:.*//`; do
            NUMBER=$((NUMBER+1))
            echo -n ${NUMBER}") "
            echo ${LINE};
         done
         echo -e -n "\nYour choice: "
         read STATION
         RECORDSTATION=`tail -n +${STATION} ~/.mplayer/channels.conf | head -n 1 | sed s/:.*//`
         echo -e -n "\nWhen do you want to start the record (format: 20:15)? "
         read RECORDSTART
         echo -e -n "\nWhen do you want to end the record (format: 22:00)? "
         read RECORDEND
         echo -e -n "\nHow should the file be named? "
         read RECORDFILE
         echo "mplayer -quiet dvb://${RECORDSTATION} -dumpstream  -dumpfile ${MOVIEFOLDER}${RECORDFILE}.ts" | at ${RECORDSTART}
         echo "killall mplayer" | at ${RECORDEND}
         echo 
         ;;
      c) echo "**************************************"
         echo "***  Cancel the record of a movie  ***"
         echo "**************************************"
         echo -e "\n"
         echo "Available at-jobs:"
         atq
         echo -e "\nI will always cancel the start- and the end-job, please only enter the number of the start-job (the one with the lower number)!"
         echo -e -n "\nWhich job do you want to cancel (0 = none)? "
         read JOB
         if [ ${JOB} -gt 0 ]; then
            atrm ${JOB}
            KILLJOB=$((${JOB}+1))
            atrm ${KILLJOB}
         fi
         ;;
      m) echo "************************************"
         echo "***   Convert movie into MPEG2   ***"
         echo "************************************"
         echo -e "\n"
         echo "Recorded movies:"
         NUMBER=0
         for LINE in `ls ${MOVIEFOLDER}`; do
            NUMBER=$((NUMBER+1))
            echo -n ${NUMBER}") "
            echo ${LINE};
         done
         echo -e -n "\nWhich movie do you want to convert to mpeg2 (0 = none)? "
         read MOVIEFOLDERNUMBER
         NUMBER=0
         if [ ${MOVIEFOLDERNUMBER} -gt 0 ]; then
            for LINE in `ls ${MOVIEFOLDER}`; do
               NUMBER=$((NUMBER+1))
               if [ $((NUMBER)) == $((MOVIEFOLDERNUMBER)) ]; then
                  MOVIEFOLDERNAME=${LINE}
               fi
            done
            MPEGNAME=$(echo ${MOVIEFOLDERNAME} | sed -e 's/\.ts/\.mpeg/') 
            ffmpeg -i ${MOVIEFOLDER}${MOVIEFOLDERNAME} -vcodec mpeg2video -vb ${VIDEOBITRATE} -acodec mp2 -ab ${AUDIOBITRATE} ${MOVIEFOLDER}${MPEGNAME}
            echo -e "\n"
            echo -e "\n"
         fi
         ;;
      p) echo "**************************************"
         echo "***      Play recorded movie       ***"
         echo "**************************************"
         echo -e "\n"
         echo "Recorded movies:"
         NUMBER=0
         for LINE in `ls ${MOVIEFOLDER}`; do
            NUMBER=$((NUMBER+1))
            echo -n ${NUMBER}") "
            echo ${LINE};
         done
         echo -e -n "\nWhich movie do you want to watch (0 = none)? "
         read MOVIEFOLDERNUMBER
         NUMBER=0
         if [ ${MOVIEFOLDERNUMBER} -gt 0 ]; then
            for LINE in `ls ${MOVIEFOLDER}`; do
               NUMBER=$((NUMBER+1))
               if [ $((NUMBER)) == $((MOVIEFOLDERNUMBER)) ]; then
                  MOVIEFOLDERNAME=${LINE}
               fi
            done
            mplayer ${MOVIEFOLDER}${MOVIEFOLDERNAME}
         fi
         ;;
      d) echo "**************************************"
         echo "***     Delete recorded movie      ***"
         echo "**************************************"
         echo -e "\n"
         echo "Recorded movies:"
         NUMBER=0
         for LINE in `ls ${MOVIEFOLDER}`; do
            NUMBER=$((NUMBER+1))
            echo -n ${NUMBER}") "
            echo ${LINE};
         done
         echo -e -n "\nWhich movie do you want to delete (0 = none)? "
         read MOVIEFOLDERNUMBER
         NUMBER=0
         if [ ${MOVIEFOLDERNUMBER} -gt 0 ]; then
            for LINE in `ls ${MOVIEFOLDER}`; do
               NUMBER=$((NUMBER+1))
               if [ $((NUMBER)) == $((MOVIEFOLDERNUMBER)) ]; then
                  MOVIEFOLDERNAME=${LINE}
               fi
            done
            rm -i ${MOVIEFOLDER}${MOVIEFOLDERNAME}
         fi
         ;;
      s) echo "**************************************"
         echo "***       Shutdown computer        ***"
         echo "**************************************"
         echo -e "\n"
         echo -n "When do you want to shutdown the computer (format: 23:15)? "
         read SHUTDOWNTIME
         su -c "echo 'shutdown -h now' | at ${SHUTDOWNTIME}"
         ;;
      i) echo "**************************************"
         echo "***  Information about tv-star.sh  ***"
         echo "**************************************"
         echo -e "\n"
         echo "Name: tv-star.sh"
         echo "Version: 0.7"
         echo "Date: 2013-10-14"
         echo "Author: Thomas Schuetz"
         echo "License: Public domain"
         echo "---------------------------------------------------"
         echo -n "There are great mediacenter-projects like MythTV, but they are too big for "
         echo -n "my simple needs. In fact, you only need one single line to record a movie, "
         echo -n "but I was too lazy to type the long line always by myself, so I created this "
         echo "little script and put everything in it, I need for handling tv."
         echo -n "The script itself is very simple, it only needs mplayer, the scan-command "
         echo -n "from the dvb-apps and some standard shell-commands. Before you really use it, "
         echo "you need to edit the variables SCANBASE and MOVIEFOLDER in the top of the script."
          ;;
      n) echo "**************************************"
         echo "***        New channel.conf        ***"
         echo "**************************************"
         echo -e "\n"
         echo -e "Creating a new channel.conf, please wait a while!\n"
         rm -f ~/.mplayer/channels.conf.old
         mv ~/.mplayer/channels.conf ~/.mplayer/channels.conf.old
         scan $SCANBASE | sed -e 's/\ /_/g' -e 's/\//_/g' -e 's/\*//' > ~/.mplayer/channels.conf
         ;;
      q) echo "**************************************"
         echo "***  Thank you for using tv-star!  ***"
         echo -e "**************************************\n"
         MAINLOOP=0
         ;;
      *) echo -e "Wrong input, please chose again!\n"
         ;;
   esac
done
